#include "classes.h"

CB3ByteStringVector::CB3ByteStringVector() {

	m_ppbsString = NULL;
	m_i32Strings = 0;
	m_i32AllocSize = 0;

}

CB3ByteStringVector::~CB3ByteStringVector() {

	for(I32 i = 0;i < m_i32Strings;i++) {
		delete m_ppbsString[i];
	}

	B3FREE_MEMORY(m_ppbsString);

}

bool CB3ByteStringVector::add(const IB3ByteString *pbsString) {

	if (pbsString == NULL || !resizeVector(m_i32Strings + 1)) {
		return false;
	}

	m_ppbsString[m_i32Strings - 1] = new CB3ByteString(pbsString);

	return true;

}

I32 CB3ByteStringVector::getSize() const { return m_i32Strings; }

IB3ByteString * CB3ByteStringVector::getString(I32 i32Index) const {

	if (i32Index < 0 || i32Index >= m_i32Strings) {
		return NULL;
	}

	return m_ppbsString[i32Index];

}

bool CB3ByteStringVector::resizeVector(I32 i32Size) {

	if (i32Size < 0) {
		return false;
	}

	if (m_i32Strings > 0) {

		IB3ByteString **ppbsTmp = (IB3ByteString **)B3ALLOC_MEMORY(sizeof(IB3ByteString *) * i32Size);

		if (ppbsTmp == NULL) {
			return false;
		}

		I32 i32Copy = m_i32Strings;

		if (i32Copy > i32Size) {
			i32Copy = i32Size;
		}

		for (I32 i = 0;i < i32Copy;i++) {
			ppbsTmp[i] = m_ppbsString[i];
		}

		B3FREE_MEMORY(m_ppbsString);

		m_ppbsString = ppbsTmp;

	} else {

		m_ppbsString = (IB3ByteString **)B3ALLOC_MEMORY(sizeof(IB3ByteString *) * i32Size);

		if (m_ppbsString == NULL) {
			return false;
		}

	}

	m_i32Strings = i32Size;

	return true;

}

bool CB3ByteStringVector::clear() {

	if (m_i32Strings == 0) {
		return true;
	}

	for(I32 i = 0;i < m_i32Strings;i++) {
		delete m_ppbsString[i];
	}

	m_i32Strings = 0;

	return true;

}
