/*
	`[grbg}bvNX
*/
#include "classes.h"

CChartBitmap::CChartBitmap() {

	m_lpdlData = NULL;

	m_iBarWidth = 5;

	clear(256, 256, 0x00ffffff);

	setClearRGB(0x00ffffff);

}

/* `Ώۃf[^ݒ */
bool CChartBitmap::setData(const CDataList *lpdlSrc) {

	if (lpdlSrc == NULL) {
		return false;
	}

	m_lpdlData = new CDataList(lpdlSrc);

	m_iStartIndex = 0;

	m_lfYRangeLow = lpdlSrc->getMinimum() - (lpdlSrc->getMax() - lpdlSrc->getMinimum());
	m_lfYRangeHigh = lpdlSrc->getMax() + (lpdlSrc->getMax() - lpdlSrc->getMinimum());

	if (m_lfYRangeLow < 0) {
		m_lfYRangeLow = 0;
	}

	return true;

}

bool CChartBitmap::drawData() {

	if (m_lpdlData == NULL) {
		return false;
	}

	clear();

	double lfYRate = (double)getHeight() / (double)(m_lfYRangeHigh - m_lfYRangeLow);

	int i;

	for (i = m_iStartIndex;i <= m_lpdlData->getLastIndex();i++) {

		int iBarX = (i - m_iStartIndex) * m_iBarWidth;
		int iLineX = iBarX + m_iBarWidth / 2;
		int iLineTop = (int)((m_lpdlData->getItem(i)->getHigh() - m_lfYRangeLow) * lfYRate);
		int iLineBottom = (int)((m_lpdlData->getItem(i)->getLow() - m_lfYRangeLow) * lfYRate);
		int iBarTop, iBarBottom;
		DWORD dwColor;

		line(iLineX, iLineTop, iLineX, iLineBottom, 0x00000000);

		if (m_lpdlData->getItem(i)->getStart() < m_lpdlData->getItem(i)->getEnd()) {
		
			iBarTop = (int)((m_lpdlData->getItem(i)->getStart() - m_lfYRangeLow) * lfYRate);
			iBarBottom = (int)((m_lpdlData->getItem(i)->getEnd() - m_lfYRangeLow) * lfYRate);

			dwColor = 0x00ffffff;

			fillRect(iBarX + 1, iBarTop + 1, iBarX + m_iBarWidth - 1, iBarBottom - 1, dwColor);
			rect(iBarX, iBarTop, iBarX + m_iBarWidth, iBarBottom, 0x00000000);

		} else {

			iBarTop = (int)((m_lpdlData->getItem(i)->getEnd() - m_lfYRangeLow) * lfYRate);
			iBarBottom = (int)((m_lpdlData->getItem(i)->getStart() - m_lfYRangeLow) * lfYRate);

			dwColor = 0x00000000;

			fillRect(iBarX, iBarTop, iBarX + m_iBarWidth, iBarBottom, dwColor);

		}

	}

	int iPrevX = 0, iPrevY = 0;

	/* Tړϐ` */
	for (i = m_iStartIndex;i <= m_lpdlData->getLastIndex();i++) {

		if (i >= 5) {

			int iX = (i - m_iStartIndex) * m_iBarWidth;
			int iY = (int)((m_lpdlData->getMA(i, 5) - m_lfYRangeLow) * lfYRate);

			if (iPrevY != 0) {

				line(iPrevX, iPrevY, iX, iY, 0x00000000);

			}

			iPrevX = iX;
			iPrevY = iY;

		}

	}

	iPrevX = 0;
	iPrevY = 0;

	/* QTړϐ` */
	for (i = m_iStartIndex;i <= m_lpdlData->getLastIndex();i++) {

		if (i >= 25) {

			int iX = (i - m_iStartIndex) * m_iBarWidth;
			int iY = (int)((m_lpdlData->getMA(i, 25) - m_lfYRangeLow) * lfYRate);

			if (iPrevY != 0) {

				line(iPrevX, iPrevY, iX, iY, 0x000000ff);

			}

			iPrevX = iX;
			iPrevY = iY;

		}

	}

	return true;

}
