#include "classes.h"

CDataItem::CDataItem() {

	m_lfStart = 0;
	m_lfHigh = 0;
	m_lfLow = 0;

}

CDataItem::CDataItem(const CDataItem *lpdiSrc) {

	m_lfStart = 0;
	m_lfHigh = 0;
	m_lfLow = 0;

	assign(lpdiSrc);

}

bool CDataItem::assign(const CDataItem *lpdiSrc) {

	if (lpdiSrc == NULL) {
		return false;
	}

	return setData(lpdiSrc->getDate(), lpdiSrc->getStart(), lpdiSrc->getHigh(), lpdiSrc->getLow(), lpdiSrc->getEnd());

}

const CDate * CDataItem::getDate() const { return (const CDate *)(&m_dtDate); }

double CDataItem::getStart() const { return m_lfStart; }
double CDataItem::getHigh() const { return m_lfHigh; }
double CDataItem::getLow() const { return m_lfLow; }
double CDataItem::getEnd() const { return m_lfEnd; }

bool CDataItem::setData(int iYear, int iMonth, int iDay, double lfStart, double lfHigh, double lfLow, double lfEnd) {

	CDate dtTmp;
	
	dtTmp.setDate(iYear, iMonth, iDay);

	return setDate(&dtTmp) && setStart(lfStart) && setHigh(lfHigh) && setLow(lfLow) && setEnd(lfEnd);

}

bool CDataItem::setData(const CDate * lpdtSrc, double lfStart, double lfHigh, double lfLow, double lfEnd) {
	return setDate(lpdtSrc) && setStart(lfStart) && setHigh(lfHigh) && setLow(lfLow) && setEnd(lfEnd);
}

bool CDataItem::setDate(int iYear, int iMonth, int iDay) {
	return m_dtDate.setDate(iYear, iMonth, iDay);
}

bool CDataItem::setDate(const CDate * lpdtSrc) {
	return m_dtDate.assign(lpdtSrc);
}

bool CDataItem::setStart(double lfStart) {

	m_lfStart = lfStart;

	return true;

}

bool CDataItem::setHigh(double lfHigh) {

	m_lfHigh = lfHigh;

	return true;

}

bool CDataItem::setLow(double lfLow) {

	m_lfLow = lfLow;

	return true;

}

bool CDataItem::setEnd(double lfEnd) {

	m_lfEnd = lfEnd;

	return true;

}
