/*
   f[^ACeXgNX
*/
#include "classes.h"
#include "B3String/classes.h"

using namespace std;

CDataList::CDataList() {}

CDataList::CDataList(const CDataList *lpdlSrc) {
	assign(lpdlSrc);
}

bool CDataList::assign(const CDataList *lpdlSrc) {

	if (lpdlSrc == NULL) {
		return false;
	}

	m_adiItems.clear();

	for (int i = 0;i <= lpdlSrc->getLastIndex();i++) {
		add(new CDataItem(lpdlSrc->getItem(i)));
	}

	return true;

}

bool CDataList::clear() {

	if (m_adiItems.size() < 1) {
		return true;
	}

	for (int i = 0;i < m_adiItems.size();i++) {
		delete m_adiItems[i];
	}

	m_adiItems.clear();

	return true;

}

bool CDataList::add(const CDataItem *lpdiSrc) {

	m_adiItems.push_back(new CDataItem(lpdiSrc));

	return true;

}

int CDataList::getLastIndex() const { return (int)m_adiItems.size() - 1; }

CDataItem * CDataList::getItem(int iIndex) {

	if (iIndex < 0 || iIndex >= (int)m_adiItems.size()) {
		return NULL;
	}

	return m_adiItems[iIndex];

}

const CDataItem * CDataList::getItem(int iIndex) const {

	if (iIndex < 0 || iIndex >= (int)m_adiItems.size()) {
		return NULL;
	}

	return (const CDataItem *)m_adiItems[iIndex];

}

/* ێĂf[^̒ŏl擾 */
double CDataList::getMinimum() const {

	if (m_adiItems.size() < 1) {
		return 0;
	}

	double lfMin = m_adiItems[0]->getLow();

	for (int i = 1;i < getLastIndex();i++) {
		if (m_adiItems[i]->getLow() < lfMin) {
			lfMin = m_adiItems[i]->getLow();
		}
	}

	return lfMin;

}

/* ێĂf[^̒ől擾 */
double CDataList::getMax() const {

	if (m_adiItems.size() < 1) {
		return 0;
	}

	double lfMax = m_adiItems[0]->getHigh();

	for (int i = 1;i < getLastIndex();i++) {
		if (m_adiItems[i]->getHigh() > lfMax) {
			lfMax = m_adiItems[i]->getHigh();
		}
	}

	return lfMax;

}

/* iIndexɂiSamples̈ړώ擾 */
double CDataList::getMA(int iIndex, int iSamples) {

	if (iIndex < 0 || iIndex < iSamples || iIndex > getLastIndex()) {
		return 0;
	}

	double lfSum = 0;

	for (int i = 0;i < iSamples;i++) {
		lfSum += getItem(iIndex - i)->getEnd();
	}

	return lfSum / iSamples;

}

/* TSVt@CǂݍŃf[^ACeXg쐬 */
bool CDataList::load(LPCTSTR lpszFilePath) {

	if (lpszFilePath == NULL) {
		return false;
	}

	CB3ByteString bsTmp;

	if (!bsTmp.loadFile((const STR8)lpszFilePath)) {
		return false;
	}

	clear();

	bsTmp.replace("\r\n", "\n");

	IB3ByteStrings *pbsLine = bsTmp.split("\n");

	for (int i = 0;i < pbsLine->getSize();i++) {

		IB3ByteStrings *pbsTSV = pbsLine->getString(i)->split("\t");

		if (pbsTSV->getSize() == 7) {

			int iYear = atoi(pbsTSV->getString(0)->c_str());
			int iMonth = atoi(pbsTSV->getString(1)->c_str());
			int iDay = atoi(pbsTSV->getString(2)->c_str());
			double lfStart = atof(pbsTSV->getString(3)->c_str());
			double lfHigh = atof(pbsTSV->getString(4)->c_str());
			double lfLow = atof(pbsTSV->getString(5)->c_str());
			double lfEnd = atof(pbsTSV->getString(6)->c_str());

			CDataItem diTmp;

			diTmp.setData(iYear, iMonth, iDay, lfStart, lfHigh, lfLow, lfEnd);

			add(&diTmp);

		}

		delete pbsTSV;

	}

	delete pbsLine;

	return true;

}
