/*
   4摜݌v}DIBSectionNX
      2004/ 5/13 ˁ@P
*/
#include "MDIBSection.h"

CMDIBSection::CMDIBSection() {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	m_dwClearBGR = 0x00000000;
	m_brClear = CreateSolidBrush(m_dwClearBGR);

	/*  */
	clear(128, 128);

}

CMDIBSection::CMDIBSection(int iWidth, int iHeight) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	m_dwClearBGR = 0x00000000;
	m_brClear = CreateSolidBrush(m_dwClearBGR);

	/*  */
	clear(iWidth, iHeight);

}

CMDIBSection::CMDIBSection(const CMDIBSection *lpdisSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	m_dwClearBGR = 0x00000000;
	m_brClear = CreateSolidBrush(m_dwClearBGR);

	assign(lpdisSrc);

}

CMDIBSection::CMDIBSection(const CMDIBSection & disSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	m_dwClearBGR = 0x00000000;
	m_brClear = CreateSolidBrush(m_dwClearBGR);

	assign(&disSrc);

}

CMDIBSection::~CMDIBSection() {

	/* DIBSection폜 */
	if (m_lppxPixels != NULL) {

		SelectObject(m_hdcBitmap, m_hbmpOld);

		DeleteObject(m_hbmpBitmap);
		DeleteDC(m_hdcBitmap);

		m_lppxPixels = NULL;

	}

	DeleteObject(m_brClear);

}

/* CMDIBSectionpZq */
CMDIBSection& CMDIBSection::operator=(const CMDIBSection& disSrc) {

	if (&disSrc != this) {
		assign(&disSrc);
	}

	return *this;

}

/* w肳ꂽrbg}bvƓe */
bool CMDIBSection::assign(const CMDIBSection * lpdisSrc) {

	if (lpdisSrc == NULL) {
		return false;
	}

	if (lpdisSrc == this) {
		return true;
	}

	if (assign(lpdisSrc)) {
		return false;
	}

	setClearBGR(lpdisSrc->m_dwClearBGR);

	m_bValid = lpdisSrc->getValid();

	return true;

}

/* w肳ꂽrbg}bvƓe */
bool CMDIBSection::assign(const HBITMAP hbmpSrc) {

	if (hbmpSrc == NULL) {
		return false;
	}

	BITMAP bmp;

	/* BITMAP\̂Ƀrbg}bv̏擾 */
	if (GetObject(hbmpSrc, sizeof(bmp), &bmp) == 0) {
		return false;
	}

	if (bmp.bmWidth * bmp.bmHeight < 1) {
		return false;
	}

	if (!clear(bmp.bmWidth, bmp.bmHeight)) {
		return false;
	}

	BITMAPINFO biTmp;

	ZeroMemory(&biTmp, sizeof(biTmp));

	/* rbg}bṽsNZpobt@m */
	LPVOID lppxPixel = (LPVOID)new DWORD[bmp.bmWidth * bmp.bmHeight];

	/* rbg}bvsNZ擾p32rbgDIBBITMAPINFOݒ */
	biTmp.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biTmp.bmiHeader.biWidth = bmp.bmWidth;
	biTmp.bmiHeader.biHeight = -bmp.bmHeight;
	biTmp.bmiHeader.biPlanes = 1;
	biTmp.bmiHeader.biBitCount = 32;

	/* sNZ擾 */
	GetDIBits(getHDC(), hbmpSrc, 0, bmp.bmHeight, lppxPixel, &biTmp, DIB_RGB_COLORS);

	/* sNZRs[ */
	CopyMemory(m_lppxPixels, lppxPixel, bmp.bmWidth * bmp.bmHeight * 4);

	/* obt@ */
	delete [] lppxPixel;

	return true;

}

/* obt@rbg}bv쐬 */
bool CMDIBSection::assign(const void *lpData, PixelDataType pdtType) {

	if (lpData == NULL) {
		return false;
	}

	int iWidth, iHeight;

	LPBITMAPINFOHEADER lpbmiHeader;

	DWORD dwOffset;

	LPBYTE lpbyBGR;

	switch (pdtType) {

	/* BMPC[W */
	case pdtBMP:

		/* BITMAPINFÕAhXݒ */
		lpbmiHeader = (LPBITMAPINFOHEADER)
		               ((LPBYTE)lpData + sizeof(BITMAPFILEHEADER));

		/* 24rbgBMPȊO͖ */
		if (lpbmiHeader->biBitCount != 24) {
			return false;
		}

		/* sNZւ̃ItZbg擾 */
		CopyMemory(&dwOffset, (LPBYTE)lpData + 10, 4);

		/* rbg}bṽTCY擾 */
		iWidth = lpbmiHeader->biWidth;
		iHeight = lpbmiHeader->biHeight;

		if (iWidth * iHeight < 1) {
			return false;
		}

		/* BMP̃TCYŏ */
		if (!clear(iWidth, iHeight)) {
			return false;
		}

		/* BMP̃sNZf[^̃|C^ */
		lpbyBGR = (LPBYTE)lpData + dwOffset;

		/* rbg}bvŜBMP̃sNZf[^ōĐݒ */
		set4BGR24(0, 0, m_iWidth, m_iHeight, lpbyBGR);

		break;

	default:

		return false;

	}

	return true;

}

void CMDIBSection::setClearBGR(DWORD dwBGR) {

	m_dwClearBGR = dwBGR;

	DeleteObject(m_brClear);

	m_brClear = CreateSolidBrush(m_dwClearBGR);

}

void CMDIBSection::setClearRGB(DWORD dwRGB) {

	BYTE byR, byG, byB;

	byR = (BYTE)((dwRGB & 0x00ff0000) >> 16);
	byG = (BYTE)((dwRGB & 0x0000ff00) >>  8);
	byB = (BYTE)(dwRGB & 0x000000ff);

	m_dwClearBGR = RGB(byR, byG, byB);

	DeleteObject(m_brClear);

	m_brClear = CreateSolidBrush(m_dwClearBGR);

}

void CMDIBSection::clear() {

	RECT rec = {0, 0, m_iWidth, m_iHeight};

	FillRect(m_hdcBitmap, &rec, m_brClear);

}

/* wTCYEwFŃNA */
bool CMDIBSection::clear(int iWidth, int iHeight, DWORD dwValue) {

	if (iWidth * iHeight < 1) {
		return false;
	}

	m_bValid = true;

	if (m_iWidth == iWidth && m_iHeight == iHeight) {

		/* SsNZwlŃNA */
		if (dwValue == 0) {
			ZeroMemory(m_lppxPixels, iWidth * iHeight * 4);
		} else {

			for (int i = 0;i < m_iHeight;i++) {
				for (int j = 0;j < m_iWidth;j++) {
					setPixel(j, i, dwValue);
				}
			}

		}

	}

	BITMAPINFO biNew;
	LPDWORD lppxNew = NULL;

	/* BITMAPINFONA */
	ZeroMemory(&biNew, sizeof(biNew));

	/* BITMAPINFOݒ */
	biNew.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biNew.bmiHeader.biWidth = iWidth;
	biNew.bmiHeader.biHeight = -iHeight;
	biNew.bmiHeader.biPlanes = 1;
	biNew.bmiHeader.biBitCount = 32;
	biNew.bmiHeader.biCompression = BI_RGB;

	/* VDIBSection쐬 */
	HBITMAP hbmpNew = CreateDIBSection(NULL, &biNew,
	            DIB_RGB_COLORS, (LPVOID *)(&lppxNew), NULL, 0);

	/* DIBSection쐬s */
	if (hbmpNew == NULL) {
		return false;
	}

	/* XN[̃foCXReLXg擾 */
	HDC hdc = GetDC(0);

	/* DIBSectionpfoCXReLXg쐬 */
	HDC hdcNew = CreateCompatibleDC(hdc);

	/* XN[̃foCXReLXg */
	ReleaseDC(0, hdc);

	/* DIBSectionpfoCXReLXg쐬s */
	if (hdcNew == NULL) {

		/* 쐬DIBSection폜 */
		DeleteObject(hbmpNew);

		return false;

	}

	/* ݂DIBSection폜 */
	if (m_lppxPixels != NULL) {

		SelectObject(m_hdcBitmap, m_hbmpOld);

		DeleteObject(m_hbmpBitmap);
		DeleteDC(m_hdcBitmap);

		m_lppxPixels = NULL;

	}

	/* Vɍ쐬DIBSection֘A̕ϐ */
	m_biHeader = biNew;
	m_lppxPixels = lppxNew;
	m_hbmpBitmap = hbmpNew;
	m_hdcBitmap = hdcNew;

	/* DIBSectionDIBSectionpfoCXReLXgɑI */
	m_hbmpOld = (HBITMAP)SelectObject(m_hdcBitmap, m_hbmpBitmap);

	/* rbg}bvTCYݒ */
	m_iWidth = iWidth;
	m_iHeight = iHeight;

	/* SsNZwlŃNA */
	if (dwValue == 0) {
		ZeroMemory(m_lppxPixels, iWidth * iHeight * 4);
	} else {

		for (int i = 0;i < m_iHeight;i++) {
			for (int j = 0;j < m_iWidth;j++) {
				setPixel(j, i, dwValue);
			}
		}

	}

	return true;

}

/* 擾 */
int CMDIBSection::getWidth() const { return m_iWidth; }

/* 擾 */
int CMDIBSection::getHeight() const { return m_iHeight; }

/* LtO擾 */
bool CMDIBSection::getValid() const { return m_bValid; }

bool CMDIBSection::Invalidate() {

	if (!clear(1, 1)) {
		return false;
	}

	m_bValid = false;

	return true;

}

/* BITMAPINFO擾 */
const BITMAPINFO * CMDIBSection::getInfo() const {
	return (const BITMAPINFO *)(&m_biHeader);
}

/* HDC擾 */
HDC CMDIBSection::getHDC() { return m_hdcBitmap; }

/* sNZ擾 */
DWORD CMDIBSection::getPixel(int iX, int iY) const {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY > m_iHeight) {
		return 0;
	}

	return m_lppxPixels[iX + iY * m_iWidth];

}

/* sNZRGB擾 */
DWORD CMDIBSection::getRGB(int iX, int iY) const {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY > m_iHeight) {
		return 0;
	}

	return getPixel(iX, iY) & 0x00ffffff;

}

/* sNZBGR擾 */
DWORD CMDIBSection::getBGR(int iX, int iY) const {

	DWORD dwBGR = getB(iX, iY) * 65536 + getG(iX, iY) * 256 + getR(iX, iY);

	return dwBGR;

}

/* R擾 */
BYTE CMDIBSection::getR(int iX, int iY) const {

	return (BYTE)((getPixel(iX, iY) & 0x00ff0000) >> 16);

}

/* G擾 */
BYTE CMDIBSection::getG(int iX, int iY) const {

	return (BYTE)((getPixel(iX, iY) & 0x0000ff00) >> 8);

}

/* B擾 */
BYTE CMDIBSection::getB(int iX, int iY) const {

	return (BYTE)(getPixel(iX, iY) & 0x000000ff);

}

/* sNZJ[L[ */
bool CMDIBSection::isColorKey(int iX, int iY) const {

	if (m_dwColorKey == 0xffffffff ||
		iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return (getRGB(iX, iY) == m_dwColorKey);

}

/* sNZݒ */
bool CMDIBSection::setPixel(int iX, int iY, DWORD dwValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	m_lppxPixels[iX + iY * m_iWidth] = dwValue;

	return true;

}

/* BGR`sNZi4oCgEjwʒuɃRs[ */
bool CMDIBSection::set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpBGR) {

	if (iWidth * iHeight < 1 || lpBGR == NULL ||
	    iX + iWidth <= 0 || iY + iHeight <= 0 ||
	    iX >= m_iWidth || iY >= m_iHeight) {
		return false;
	}

	int iLength;

	/* sNZ̉vZ */
	if (iWidth % 4 == 0) {
		iLength = iWidth * 3;
	} else {
		iLength = iWidth * 3 + (4 - (iWidth * 3) % 4);
	}

	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* ̈ȂsNZݒ */
			if (iX + j >= 0 && iX + j < m_iWidth &&
				iY + i >= 0 && iY + i < m_iHeight) {

				/* RGBl쐬 */
				DWORD dwRGB = ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength] +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 1] * 256 +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 2] * 65536;

				/* RGBݒ */
				setRGB(iX + j, iY + i, dwRGB);

			}

		}
	}

	return true;

}

/* sNZRGBݒ */
bool CMDIBSection::setRGB(int iX, int iY, DWORD dwValue) {

	return setPixel(iX, iY, dwValue & 0x00ffffff);

}

/* sNZRݒ */
bool CMDIBSection::setR(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xff00ffff;
	dwPixel |= iValue << 16;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZGݒ */
bool CMDIBSection::setG(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xffff00ff;
	dwPixel |= iValue << 8;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZBݒ */
bool CMDIBSection::setB(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xffffff00;
	dwPixel |= iValue;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZRZ */
bool CMDIBSection::addR(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setR(iX, iY, getR(iX, iY) + iValue);

	return true;

}

/* sNZGZ */
bool CMDIBSection::addG(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setG(iX, iY, getG(iX, iY) + iValue);

	return true;

}

/* sNZBZ */
bool CMDIBSection::addB(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setB(iX, iY, getB(iX, iY) + iValue);

	return true;

}

/* sNZRZ */
bool CMDIBSection::mulR(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setR(iX, iY, int(getR(iX, iY) * lfValue));

	return true;

}

/* sNZGZ */
bool CMDIBSection::mulG(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setG(iX, iY, int(getG(iX, iY) * lfValue));

	return true;

}

/* sNZBZ */
bool CMDIBSection::mulB(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setB(iX, iY, int(getB(iX, iY) * lfValue));

	return true;

}

bool CMDIBSection::alphaBlend(int iX, int iY, DWORD dwRGB, double lfRate) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight ||
	    lfRate < 0 || lfRate > 1.0) {
		return false;
	}

	double lfR = getR(iX, iY);
	double lfG = getG(iX, iY);
	double lfB = getB(iX, iY);

	double lfR2 = (dwRGB & 0x00ff0000) >> 16;
	double lfG2 = (dwRGB & 0x0000ff00) >> 8;
	double lfB2 = dwRGB & 0x000000ff;

	lfR = (1.0 - lfRate) * lfR + lfRate * lfR2;
	lfG = (1.0 - lfRate) * lfG + lfRate * lfG2;
	lfB = (1.0 - lfRate) * lfB + lfRate * lfB2;

	setR(iX, iY, (int)lfR);
	setG(iX, iY, (int)lfG);
	setB(iX, iY, (int)lfB);

	return true;

}

/* nꂽf[^ŃsNZݒ */
bool CMDIBSection::setPixels(const void *lpData, PixelDataType pdtType) {

	if (lpData == NULL) {
		return false;
	}

	int iLength;

	switch (pdtType) {

	/* 24rbgBGRsNZ */
	case pdt4BGR24:

		if (m_iWidth % 4 == 0) {
			iLength = m_iWidth * 3;
		} else {
			iLength = m_iWidth * 3 + (4 - (m_iWidth * 3) % 4);
		}

		/* 24-32rbgϊȂsNZݒ */
		for (int i = 0;i < m_iHeight;i++) {
			for (int j = 0;j < m_iWidth; j++) {
				CopyMemory(getScanLine(i) + j,
				           (LPBYTE)lpData + j * 3 + (m_iHeight - i - 1) * iLength, 3);
			}
		}

		return true;

		break;

	}

	return false;

}

/* J[L[擾 */
DWORD CMDIBSection::getColorKey() const { return m_dwColorKey; }

/* J[L[ݒ */
bool CMDIBSection::setColorKey(DWORD dwValue) {

	m_dwColorKey = dwValue;

	return true;

}

/* wssNZ̃AhX擾 */
LPDWORD CMDIBSection::getScanLine(int iY) {

	if (iY < 0 || iY >= m_iHeight) {
		return NULL;
	}

	return m_lppxPixels + m_iWidth * iY;

}

/* wssNZ̃AhX擾 */
const DWORD * CMDIBSection::getScanLine(int iY) const {

	if (iY < 0 || iY >= m_iHeight) {
		return NULL;
	}

	return (const DWORD *)(m_lppxPixels + m_iWidth * iY);

}

/* rbg}bvwfoCXReLXgɓߕ` */
bool CMDIBSection::draw(HDC hdcDst, int iX, int iY) const {

	/* J[L[ݒȂÂ܂ܑŜ` */
	if (m_dwColorKey == 0xffffffff) {

		SetDIBitsToDevice(hdcDst, iX, iY, m_iWidth, m_iHeight,
		     0, 0, 0, m_iHeight, m_lppxPixels, &m_biHeader,
	         DIB_RGB_COLORS);

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(j, i)) {
				SetPixel(hdcDst, iX + j, iY + i, getBGR(j, i));
			}

		}
	}

	return true;

}

/* rbg}bvwrbg}bvɓߕ` */
bool CMDIBSection::draw(CMDIBSection *lpdisDst, int iX, int iY) const {

	if (lpdisDst == NULL) {
		return false;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {
		return draw(lpdisDst->getHDC(), iX, iY);
	}

	return draw(lpdisDst, iX, iY);

}

/* 摜t@Cǂݍ */
bool CMDIBSection::load(LPCTSTR lpszFilePath) {

	if (lpszFilePath == NULL) {
		return false;
	}

	LPBYTE lpBuf;
	HANDLE fh;
	DWORD dwLoad;

	fh = CreateFile(lpszFilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@Cǂݍ݃obt@m */
	lpBuf = new BYTE[GetFileSize(fh, NULL)];

	/* t@Cobt@ɉ摜f[^ǂݍ */
	ReadFile(fh, lpBuf, GetFileSize(fh, NULL), &dwLoad, NULL);

	CloseHandle(fh);

	/* ǂݍ񂾉摜t@CC[WŃrbg}bv쐬 */
	if (assign(lpBuf, pdtBMP)) {

		delete[] lpBuf;
		return true;

	} else {

		delete[] lpBuf;
		return false;

	}

}

/* rbg}bv24rbgtJ[BMPɕۑ */
bool CMDIBSection::save(LPCTSTR lpszFilePath) const {

	if (lpszFilePath == NULL || m_iWidth * m_iHeight < 1) {
		return false;
	}

	int iLength = m_iWidth * 3;

	/* sNẐPC̒Zo */
	if (iLength % 4 != 0) {
		iLength = m_iWidth * 3 + (4 - (m_iWidth * 3) % 4);
	}

	/* t@CTCYvZ */
	DWORD dwSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + iLength * m_iHeight;

	/* opobt@m */
	LPBYTE lpData = new BYTE[dwSize];

	/* obt@NA */
	ZeroMemory(lpData, dwSize);

	/* BMwb_ݒ */
	lpData[0] = (BYTE)'B';
	lpData[1] = (BYTE)'M';

	/* t@CTCYݒ */
	CopyMemory(lpData + 6, &dwSize, 4);

	/* sNZ܂ł̃ItZbgݒ */
	lpData[10] = 54;

	LPBITMAPINFOHEADER lpbmiHeader = (LPBITMAPINFOHEADER)(lpData + 14);
	LPBYTE lpPixel = lpData + 54;

	/* 24rbgtJ[BMPpBITMAPINFOHEADERݒ */
	lpbmiHeader->biSize = 40;
	lpbmiHeader->biWidth = m_iWidth;
	lpbmiHeader->biHeight = m_iHeight;
	lpbmiHeader->biPlanes = 1;
	lpbmiHeader->biBitCount = 24;

	/* sNZ̓e24rbgŏo */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			lpPixel[j * 3 + i * iLength] = getB(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 1] = getG(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 2] = getR(j, m_iHeight - i - 1);

		}
	}

	DWORD dwWrote;

	/* t@C쐬 */
	HANDLE hFile = CreateFile(lpszFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@C */
	WriteFile(hFile, lpData, dwSize, &dwWrote, NULL);

	CloseHandle(hFile);

	/* opobt@폜 */
	delete[] lpData;

	if (dwWrote == dwSize) {
		return true;
	} else {
		return false;
	}

}

bool CMDIBSection::line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	if (iX1 == iX2 && iY1 == iY2) {
		return false;
	}

	HPEN hpenTmp, hpenOld;
	DWORD dwR, dwG, dwB;

	dwR = (dwRGB & 0x00ff0000) >> 16;
	dwG = (dwRGB & 0x0000ff00) >> 8;
	dwB = dwRGB & 0x000000ff;

	iY1 = m_iHeight - iY1 - 1;
	iY2 = m_iHeight - iY2 - 1;

	hpenTmp = CreatePen(PS_SOLID, 1, RGB(dwR, dwG, dwB));

	hpenOld = (HPEN)SelectObject(m_hdcBitmap, hpenTmp);

	MoveToEx(m_hdcBitmap, iX1, iY1, NULL);
	LineTo(m_hdcBitmap, iX2, iY2);

	SelectObject(m_hdcBitmap, hpenOld);

	DeleteObject(hpenTmp);

	return true;

}

bool CMDIBSection::rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (line(iX1, iY1, iX2, iY1, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY1, iX2, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY2, iX1, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX1, iY2, iX1, iY1, dwRGB)) {
		bResult = true;
	}

	return bResult;

}

bool CMDIBSection::fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (iX1 == iX2 || iY1 == iY2) {
		return line(iX1, iY1, iX2, iY2, dwRGB);
	}

	if (iY1 < iY2) {

		for (int i = iY1;i <= iY2;i++) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	if (iY1 > iY2) {

		for (int i = iY1;i >= iY2;i--) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	return bResult;

}

bool CMDIBSection::textOut(int iX, int iY, LPCTSTR lpszSrc, DWORD dwRGB) {

	if (lpszSrc == NULL) {
		return false;
	}

	iY = m_iHeight - iY - 1;

	SetTextColor(m_hdcBitmap, getCOLORREF(dwRGB));

	SetBkMode(m_hdcBitmap, TRANSPARENT);

	TextOut(m_hdcBitmap, iX, iY, lpszSrc, lstrlen(lpszSrc));

	return true;

}

COLORREF CMDIBSection::getCOLORREF(DWORD dwRGB) const {

	DWORD dwR, dwG, dwB;

	dwR = (dwRGB & 0x00ff0000) >> 16;
	dwG = (dwRGB & 0x0000ff00) >> 8;
	dwB = dwRGB & 0x000000ff;

	return RGB(dwR, dwG, dwB);

}

HBITMAP CMDIBSection::getHBITMAP() const { return m_hbmpBitmap; }

HDC CMDIBSection::getHDC() const { return m_hdcBitmap; }
